;----------------------------------;
; Digital Invadors on 1816BE48     ;
;     14.12.2021 (c) Lavr          ;
;----------------------------------;

;-DATA buffer @
 .EQU BUF, #032; 8 bytes buffer
 .EQU NUM, #040; INT Number
 .EQU AIM, #041; Gun Power
 .EQU GUN, #042; Gun Symbol
 .EQU SHT, #043; Shoot number
 .EQU ARM, #044; Rockets number
 .EQU RND, #045; Current-byte RND
 .EQU PRE, #046; Previous-byte RND
 .EQU SYM, #047; Symbol
 .EQU ENM, #030H; Invadors number
 .EQU RGL, #031H; Saved L
 .EQU RGH, #032H; Saved H
 .EQU KEY, #033H; Key pressed
 .EQU SCR, #034H; SCORE 3 Byte

;-reset vector---------------------
 .ORG  0
  DIS  I       ; disable interrupts
  JMP  MAIN

;-external interrupt vector--trap
 .ORG  3
HERE:
  JMP  HERE    ; dead loop

;-timer interrupt vector------------------
;-   
;- R0,R2,R3
 .ORG  7
  SEL  RB1     ;  .
  MOV  R6,A    ;  Save A
  MOV  A,#0D5H ;  256-213=43  * 80 = 3440  = 3,44mS
  MOV  T,A     ;   43 

  MOV  A,BUF-1
  ADD  A,R3
  MOV  R0,A    ;   
  MOV  A,@R0   ;   

  OUTL P1,A    ;    - 

  MOV  A,R2    ;  
  INC  A       ;   
  MOV  R2,A    ;  
; RL   A
  SWAP A       ;   
  OUTL P2,A    ;   

  DJNZ R3,EXIT_TMR
  MOV  R2,#07H ;     R3=1
  MOV  R3,#08H

EXIT_TMR:
;  MOV  A,R4    ;  
;  INC  A       ;  
;  MOV  R4,A    ;  

  SEL  RB0     ;   
  MOV  A,#0D8H ;  256-216=40  * 80 = 3200  = 3,2mS
  MOV  T,A     ;   40 
  MOV  A,R6    ;  Restore A
  RETR

;- MAIN -----------
MAIN:
  ;INITIALIZE

  DIS  TCNTI      ; turn off counter

  MOV  R0,NUM
  MOV  R2,#22
  CLR  A
CLE:
  MOV  @R0,A
  INC  R0
  DJNZ R2,CLE

  MOV  R0,ARM
  MOV  A,#3CH     ; #3CH = Rockets 
  MOV  @R0,A

  MOV  R0,RND
  MOV  A,#07H
  MOV  @R0,A

  MOV  R0,ENM
  MOV  A,#30H    ; #30H = 48 Enemys
  MOV  @R0,A
  OUTL BUS,A     ; Disp.Enemys
  INC  R0

  MOV  R1,#0
  MOV  R5,#0
  CALL COPY_BUF

  SEL  RB1       ; .
  MOV  R2,#07H   ; 1110h - CT position
  MOV  R3,#08H   ; R3 = buf offset
  MOV  R4,#00H   ; R4 =  
  SEL  RB0       ;  

  MOV  A,#0E5H   ; 256-229=27  * 80 = 2160  = 2,16mS
  MOV  T,A       ;  27 
  STRT T         ;  
  EN   TCNTI     ;   
;-------------------------------------------------
; 00h - 07h (bank 0)
; 08h - 17h (stack memory: 8-23)
; 18h - 1Fh (bank 1: 24-31)
; 20h - 3Fh (free memory: 32-63)
; R0, R1 = H,L
; R2, R3 = D,E
; R4, R5 = B,C
; R6, R7 = T1,T2 Temp reg.
;-------------------------------------------------
MAIN_LOOP:
;-       
   CALL DELAY100; R5,R6
;-  DELAY100 ~ 1FH, 20H 
;-   3,2mS ?

;  SEL  RB1     ; .
;  MOV  A,R4    ;  
;  OUTL BUS,A   ;  -> BUS
;  XRL  A,R4    ; A=0
;  MOV  R4,A    ;  
;  SEL  RB0     ;  

   MOV  R0,KEY  ;
   MOV  R1,SHT  ; Shoot count
   MOV  A,@R1
   JNZ  MA1     ; T1 is Shooting
   JT1  MA1     ; T1 NOT Pressed
   CALL FIRE    ; T1 Pressed !!!
   JMP  MAIN_LOOP
MA1:
   JT0  MA2     ; T0 NOT Pressed
   MOV  A,@R0
   JNZ  MA3
   MOV  A,#0FFH
   MOV  @R0,A
   CALL DOUP
   JMP  MA3
MA2:
   CLR  A
   MOV  @R0,A
MA3:
   CALL VIEW
   JMP  MAIN_LOOP

DOUP:
   MOV  R1,AIM  ; Gun Power
   MOV  A,@R1
   INC  A
   MOV  R7,A    ; Save A
   ADD  A,#0F4H ; -12
   JNC  DO1
   CLR  A       ; A = 0
   MOV  R7,A    ; Save A
DO1:
   MOV  A,R7    ; Restore A
   MOV  R1,AIM  ; Gun Power
   MOV  @R1,A   ; Save 7-Seg Digit
   CALL DIG     ; GET 7-Seg Digit
   MOV  R1,BUF+7;
   MOV  @R1,A   ; Save 7-Seg Digit
   CALL BEEP
   RET

FIRE:
   MOV  R0,ARM   ; Rockets
   MOV  A,@R0    ; Get Rockets
   JZ   F00      ; NO Rockets!

   MOV  R1,SHT   ; Shoot count
   MOV  A,06H    ; poz.counter
   MOV  @R1,A

   MOV  R1,BUF+6 ; 0"E"<-
   DIS  TCNTI
   MOV  A,@R1
   EN   TCNTI
   MOV  R0,GUN   ; save "E"
   MOV  @R0,A

   MOV  A,39H    ; "C"
   DIS  TCNTI
   MOV  @R1,A
   EN   TCNTI
   MOV  R1,BUF+5 ; 0"E"x<-?
   DIS  TCNTI
   MOV  A,@R1    ; is it empty?
   EN   TCNTI
   JZ   FIZ      ; Enemy NOT near!!!
   MOV  R1,RGH   ;
   MOV  A,0FFH   ;
   MOV  @R1,A    ; Enemy near Flag!!!
   JMP  FIX
FIZ:
   MOV  A,40H    ; "-" set boolet
   DIS  TCNTI
   MOV  @R1,A
   EN   TCNTI
   MOV  R1,RGH   ;
   CLR  A
   MOV  @R1,A    ; Enemy NOT near!!!
FIX:
   CALL SND      ; Shoot sound
   RET
F00:
   CALL BEEP     ; NO ARM!
   RET

  .ORG  100H
VIEW:
   MOV  R1,NUM
   MOV  A,@R1
   INC  A
   MOV  @R1,A
;  BUF  7 6 5 4 3 2 1 0
;       _ _ _ _ _ _ E 8
;       0 1 2 3 4 5 6 7
   MOV  R1,SHT   ; Shoot count
   MOV  A,@R1    ; Get it
   JZ   DEND     ; no Shoot test new enemy

   ADD  A,BUF    ; BUF + Shoot count
   DEC  A        ; Back 1 symb
   MOV  R1,A     ; Offset to current symbol
   DIS  TCNTI
   MOV  A,@R1    ; Get current symbol
   EN   TCNTI
   MOV  R2,A     ; Save symbol

   MOV  A,R1     ; Get current poz.
   DEC  A
   MOV  R7,A     ; Save poz.

   MOV  A,R2     ; Get symbol
   ADD  A,#0C0H  ; A-40H: is it "-" ?
   JZ   MM0      ; YES it is "-"!
MMM:
   MOV  R1,BUF+7 ; 0<-"E"
   DIS  TCNTI
   MOV  A,@R1    ; Get first symbol
   EN   TCNTI
   CPL  A        ; A = /A
   INC  A        ; A = -A
   ADD  A,R2     ; CMP first & current
   JZ   BUM      ; YES! It digit in 1-st poz.

   CLR  A        ; A = 0
   MOV  R1,SHT   ; Shoot count
   MOV  @R1,A    ; Set NO Shoot
   JMP  MN1
MM0:
   CLR  A        ; A = 0
   DIS  TCNTI
   MOV  @R1,A    ; Clear current "-"
   EN   TCNTI
   DEC  R1       ; Next pozition
   MOV  A,R1     ; Save
   MOV  R0,A     ; Next pozition->R0
   DIS  TCNTI
   MOV  A,@R1    ; Get current
   EN   TCNTI
   JZ   MN0      ; If clear Put "-"

   MOV  R2,A     ; Save symbol
   CPL  A
   INC  A
   ADD  A,40H
   JZ   MN0      ; If "-" Put "-"

   MOV  A,R2     ; Restore symbol
   MOV  R2,A     ; Save symbol
   MOV  R1,SHT   ; Shoot count
   MOV  A,@R1    ; Get Shoot count
   DEC  A        ; A=Shoot count-1
   MOV  @R1,A    ; Save Shoot count
   MOV  A,R2     ; Restore symbol
   JMP  MMM      ; Test KILL!
MN0:
   MOV  R1,SHT   ; Shoot count
   MOV  A,@R1    ; Get Shoot count
   DEC  A        ; A=Shoot count-1
   MOV  @R1,A    ; Save Shoot count
   JNZ  MM1      ; Put "-"
MN1:
   MOV  R1,ARM   ; Rocket count
   MOV  A,@R1    ; Get count
   JZ   MN3      ; No Rockets - RET

   DEC  A        ; Rockets - 1
   MOV  @R1,A    ; Save Rockets
;  OUTL BUS,A    ; Rockets -> BUS
   JNZ  MN2

   MOV  R1,GUN   ; Saved ARM symbol
   MOV  A,@R1    ; Get ARM symbol
   MOV  R1,RGH   ; ARM symbol
   MOV  @R1,A    ; Save ARM symbol

   MOV  R1,BUF+6 ; 0"E"<-
   MOV  A,3FH    ; = "0"
   DIS  TCNTI
   MOV  @R1,A    ; Save No Rockets
   EN   TCNTI
   JMP  MN3
MN2:
   MOV  R1,GUN   ; ARM symbol
   MOV  A,@R1    ; Get ARM symbol
   MOV  R1,BUF+6 ; 0"E"<-
   DIS  TCNTI
   MOV  @R1,A    ; Save ARM symbol
   EN   TCNTI
MN3:
   RET
MM1:
   MOV  A,#40H   ; "-"
   DIS  TCNTI
   MOV  @R0,A    ; Save "-" at current
   EN   TCNTI
   RET
DEND:
   MOV  R1,NUM   ; Time to add enemy
   MOV  A,@R1
   ADD  A,#0C0H  ; -48H
   JNZ  DEN1
   CLR  A
   MOV  @R1,A    ; Clear Time to add
   CALL RAND     ; show new enemy!
DEN1:
   RET
;----------------
BUM:
   MOV  R1,RGH   ;
   MOV  A,@R1    ; Enemy near Flag!!!
   JZ   BUN
   INC  R7
BUN:
   MOV  A,R7     ; Get current poz.
BU0:
   MOV  R1,A     ; hgfedcba
   MOV  A,#3FH   ;
   MOV  @R1,A
   CALL DDS      ; R3,R4,R5,R6
   CALL DELAY100 ; R5,R6
   MOV  A,#49H   ;
   MOV  @R1,A
   CALL DDS      ; R3,R4,R5,R6
   CALL DELAY100 ; R5,R6
   MOV  A,#48H   ;
   MOV  @R1,A
   CALL DDS      ; R3,R4,R5,R6
   CALL DELAY100 ; R5,R6
   MOV  A,#08H   ; 00001000
   MOV  @R1,A
   CALL DDS      ; R3,R4,R5,R6
   CALL DELAY100 ; R5,R6

   CALL COUNT

   MOV  A,#00H   ;
   MOV  @R1,A
   MOV  R1,SHT   ; Shoot count
   MOV  @R1,A    ; Shoot count =0
   MOV  R1,ENM   ;
   MOV  A,@R1    ; Get Enemys
   DEC  A
   MOV  @R1,A    ; Save Enemys
   OUTL BUS,A    ; Disp.Enemys
   JNZ  BU1
   JMP  WIN
BU1:
   CALL DELAY100 ; R5,R6
   JMP  MN1

COUNT:
   MOV  A,R2     ; Get Symbol
;  OUTL BUS,A    ; Symbol -> BUS
   MOV  R3,A     ; Save Symbol

   MOV  R0,SHT   ; Shoot count
   MOV  A,@R0    ; Get count
;  OUTL BUS,A    ; Shoot count -> BUS
   RL   A
   RL   A
   RL   A
   RL   A        ; 01 -> 10
   MOV  R2,A     ; Save it
   CALL SOLV

   MOV  A,R3     ; Get Symbol
   CPL  A
   INC  A
   MOV  R3,A     ; Save Symbol
   ADD  A,#5CH   ; "o" ?
   JNZ  CO1      ; Not"o"

   MOV  R2,#80H  ; UFO"o"
   CALL SOLV
   JMP  CO5
CO1:
   MOV  A,R3     ; Get Symbol
   ADD  A,#63H   ; "" ?
   JNZ  CO5      ; Not""

   MOV  R2,#90H  ; UFO""
   CALL SOLV
CO5:
   RET

SOLV:
   MOV  R0,SCR   ; Score Buffer Low
   MOV  A,@R0    ; Get Score Low
   ADD  A,R2     ; Inc Score Low
   DA   A        ; Decimal Adjust
   MOV  @R0,A    ; Save Score Low
;  OUTL BUS,A    ; Score Low -> BUS

   INC  R0       ; Score Buffer Mid
   MOV  A,@R0    ; Get Score Mid
   ADDC A,#0     ; Inc Score Mid
   DA   A        ; Decimal Adjust
   MOV  @R0,A    ; Save Score Mid

   INC  R0       ; Score Buffer Hi
   MOV  A,@R0    ; Get Score Hi
   ADDC A,#0     ; Inc Score Hi
   DA   A        ; Decimal Adjust
   MOV  @R0,A    ; Save Score Hi
   RET

  .ORG  200H
RAND:
   MOV  R0,RND
   MOV  A,@R0    ; Get Prev.RND
   MOV  R2,A     ; = Prev.RND
   ADD  A,R2     ; 2xPrev.RND
   MOV  R3,A     ; = 2xPrev.RND
   ADD  A,R3     ; 4xPrev.RND
   ADD  A,R2     ; 5xPrev.RND
   INC  A        ; 5xPrev.RND+1
   MOV  @R0,A    ; Save New RND
   MOV  R2,A     ; Copy New RND

   ADD  A,#0C0H  ; -64
   JNC  DIV      ; A > 64
   MOV  A,R2     ; Restore New RND
   ANL  A,#0FH   ; Low Nibble
   JMP  RDY
DIV:
   MOV  A,R2     ; Restore New RND
   ANL  A,#0F0H  ; Hi Nibble
   RR   A
   RR   A
   RR   A
   RR   A        ; Hi->Low Nibble
RDY:
   MOV  R2,A     ; Copy New Low Nibble
   ADD  A,#0F4H  ; -12
   JC   RAND     ; A > 11 Again!

   MOV  R0,PRE
   MOV  A,@R0    ; Get PRE.RND
   CPL  A        ; A=/A
   INC  A        ; A=/A+1=-A
   ADD  A,R2     ; NewRND=PRE.RND?
   JZ   RAND

   MOV  A,R2     ; A=NewRND
   MOV  @R0,A    ; Save NewRND->PRE.RND
   CALL DIG      ; GET 7-Seg Digit
   MOV  R2,A     ; Copy New Digit
;  BUF  7 6 5 4 3 2 1 0
;       _ _ _ _ _ _ E 8
;       0 1 2 3 4 5 6 7
   MOV  R3,#05H  ; OE_5.4321
   MOV  R0,BUF+5 ; First after GUN
   MOV  R1,BUF+4 ; Second after GUN
   MOV  A,@R0    ; Get First...
   JZ   RD0      ; is it empty ?
   CPL  A
   INC  A        ; A=-A
   ADD  A,#40H
   JZ   RD0
   JMP  EWIN     ; NO! Enemy WIN!
RD0:
   ORL  P1,#80H  ; 1000.0000b
   MOV  A,@R1    ; Get byte before
   MOV  @R0,A    ; Put it after
   DEC  R0
   DEC  R1
   DJNZ R3,RD0
   MOV  A,R2     ; Restore New Digit
   MOV  @R0,A    ; Put it last
   ANL  P1,#7FH  ; 0111.1111b
   RET

EWIN:
;-- Enemy WIN!
   MOV  R0,BUF+6 ; -> GUN
   MOV  A,@R0    ; Get GUN
   MOV  R7,A     ; Copy GUN
   CPL  A
   INC  A
   ADD  A,#3FH   ; -3FH "0" ?
   JZ   EWI      ; GUN Empty "0" ?
   JMP  EWW      ;
EWI:
   MOV  R1,RGH   ; ARM symbol
   MOV  A,@R1    ; Get ARM symbol
   OUTL BUS,A    ; FIN -> BUS
   MOV  R7,A     ; Copy GUN
EWW:
   MOV  A,R7     ; Restore GUN
   MOV  R1,GUN
   MOV  @R1,A    ; Save GUN
EW0:
   MOV  A,#0FH   ; 00001111
   MOV  @R0,A    ; Clear GUN
   INC  R0
   MOV  A,#39H   ; 00111001
   MOV  @R0,A    ; Clear AIM
   DEC  R0
   CALL DDS      ; R3,R4,R5,R6
   CALL DELAY100 ; R5,R6

   MOV  A,#49H   ;
   MOV  @R0,A    ; Clear GUN
   INC  R0
   MOV  @R0,A    ; Clear AIM
   DEC  R0
   CALL DDS      ; R3,R3,R4,R5,R6
   CALL DELAY100 ; R5,R6

   MOV  A,#48H   ;
   MOV  @R0,A    ; Clear GUN
   INC  R0
   MOV  @R0,A    ; Clear AIM
   DEC  R0
   CALL DDS      ; R3,R4,R5,R6
   CALL DELAY100 ; R5,R6

   MOV  A,#08H   ;
   MOV  @R0,A    ; Clear GUN
   INC  R0
   MOV  @R0,A    ; Clear AIM
   DEC  R0
   CALL DDS      ; R3,R4,R5,R6
   CALL DELAY100 ; R5,R6

   MOV  A,#00H   ;
   MOV  @R0,A    ; Clear GUN
   INC  R0
   MOV  @R0,A    ; Clear AIM
   CALL DDS      ; R3,R4,R5,R6
   CALL DELAY100 ; R5,R6

   CALL INIT     ; Clear All

   MOV  A,R7     ; Get GUN
   CPL  A
   INC  A
   ADD  A,49H    ; CPI 49H; "E" ?
   JNZ  EW1      ;   49H

   MOV  A,#48H   ; =48H; "="
   JMP  EW3
EW1:
   MOV  A,R7     ; Get GUN
;  OUTL BUS,A    ; GUN -> BUS
   CPL  A
   INC  A
   ADD  A,48H    ; CPI 8H; "=" ?
   JNZ  FIN      ;   48H
EW2:
   MOV  A,#40H   ; "-"
EW3:
   MOV  R1,GUN
   MOV  @R1,A    ; Save GUN
   MOV  R1,BUF+6
   MOV  @R1,A    ; Put GUN
   RET
FIN:
   MOV  A,#08H   ; "_"
   CALL FIL
   CALL ONESEC
   CALL ONESEC

   MOV  A,#00H   ; "_"
   CALL FIL
   CALL DELAY100 ;
   CALL SND
FI1:
   MOV  R1,#08H
   MOV  R5,#00H
   CALL COPY_BUF
   CALL ONESEC
   CALL ONESEC

   CALL DDS      ; R3,R4,R5,R6
   MOV  A,#00H   ; "_"
   CALL FIL
   CALL DELAY100 ;
   JMP  FIN

FIL:
   MOV  R1,BUF
   MOV  R2,#08H
FI0:
   MOV  @R1,A    ;
   INC  R1
   DJNZ R2,FI0
   RET


 .ORG  300H
SUBS:
;----------------
; copy from msg_table to display buffer 8 bytes
; R1 = msg_table offset
;----------------
COPY_BUF:
  MOV  R0,BUF ;    : BUF, 032h...039h; 8 bytes buffer
  MOV  R2,8
COPY_LP:
  MOV  A,R1
  ADD  A,#MSG_TABLE-#SUBS
  MOVP A,@A       ; Move from memory A=[PC<11:8>+A]
  MOV  @R0,A      ;
  INC  R0
  INC  R1
  DJNZ R2,COPY_LP
  RET

MSG_TABLE:
  .DB #06H     ;1
  .DB #00H     ;_
  .DB #00H     ;_
  .DB #00H     ;_
  .DB #00H     ;_
  .DB #00H     ;_
  .DB #049H    ;E
  .DB #03FH    ;0
OPS:
  .DB #08H     ;_
  .DB #08H     ;_
  .DB #6DH     ;S
  .DB #73H     ;P
  .DB #3FH     ;O
  .DB #3FH     ;O
  .DB #08H     ;_
  .DB #08H     ;_
YRA:
  .DB #6BH     ;!_01101011b
  .DB #6EH     ;Y
  .DB #77H     ;A
  .DB #77H     ;A
  .DB #50H     ;r
  .DB #5CH     ;o
  .DB #5CH     ;o
  .DB #76H     ;H

DIG:
  ADD  A,#TAB-#SUBS
  MOVP A,@A       ; Move from memory A=[PC<11:8>+A]
  RET

TAB:
  .DB #3FH ; 0  63D
  .DB #06H ; 1   6D
  .DB #5BH ; 2  91D
  .DB #4FH ; 3  79D
  .DB #66H ; 4 102D
  .DB #6DH ; 5 109D
  .DB #7DH ; 6 125D
  .DB #07H ; 7   7D
  .DB #7FH ; 8 127D
  .DB #6FH ; 9 111D
  .DB #5CH ; o
  .DB #63H ; 
  .DB #63H ; 

;-- Sound1 --- R4,R5,R6
SND:
   MOV  R4,#30H
L32:
   MOV  A,R4
   MOV  R5,A
   MOV  R6,A
   ORL  P1,#80H  ; 1000.0000b
L33:
   NOP
   DJNZ R5,L33
   ANL  P1,#7FH  ; 0111.1111b
L34:
   NOP
   DJNZ R6,L34
   NOP
   DJNZ R4,L32
   RET
;-- Sound2 --- R3,R4,R5,R6
DDS:
   MOV  R3,#30H
   MOV  R4,#02H
M32:
   MOV  A,R4
   MOV  R5,A
   MOV  R6,A
   ORL  P1,#80H  ; 1000.0000b
M33:
   NOP
   DJNZ R5,M33
   ANL  P1,#7FH  ; 0111.1111b
M34:
   NOP
   DJNZ R6,M34
   INC  R4
   DJNZ R3,M32
   RET
;-- Sound3 --- R4,R5,R6
BEEP:
   MOV  R4,#10H
BEE:
   MOV  R5,#50H
   MOV  R6,#50H
   ORL  P1,#80H  ; 1000.0000b
BE0:
   DJNZ R5,BE0
   ANL  P1,#7FH  ; 0111.1111b
BE1:
   DJNZ R6,BE1
   NOP
   DJNZ R4,BEE
   RET
;---------------- R5,R6
DELAY100:
   MOV  R6,#84
LOOPEX:
   MOV  R5,#236
LOOPIN:
   DJNZ R5,LOOPIN
   DJNZ R6,LOOPEX
   MOV  R6,#4
LOOPAD:
   DJNZ R6,LOOPAD
   RET

;---------------- R4,R5,R6
ONESEC:
  MOV  R4,#10
LOOP_D:
  CALL DELAY100
  DJNZ R4,LOOP_D
  RET

INIT:
   MOV  R1,BUF+7
   MOV  R2,#06H
   MOV  A,#03FH
   MOV  @R1,A    ;
   DEC  R1
   MOV  A,#049H
   MOV  @R1,A    ;
   DEC  R1
   MOV  A,#00H
INI0:
   MOV  @R1,A    ;
   DEC  R1
   DJNZ R2,INI0

   MOV  R0,ARM
   MOV  A,#3CH
   MOV  @R0,A

   MOV  R0,ENM
   MOV  A,#30H  ; New.Enemys
   MOV  @R0,A
   OUTL BUS,A   ; Disp.Enemys

   MOV  R0,AIM
   MOV  A,#00H
   MOV  @R0,A
   MOV  R0,SCR
   MOV  @R0,A
   INC  R0
   MOV  @R0,A
   INC  R0
   MOV  @R0,A
   RET

WIN:
   MOV  R1,#16
   MOV  R5,#00H
   CALL COPY_BUF
   CALL SND      ; R4,R5,R6
   CALL ONESEC
   CALL ONESEC
   CALL ONESEC
   MOV  A,#00H   ; " "
   CALL FIL
   CALL DELAY100 ;

   MOV  R1,BUF+7 ; 0<-"E"
   MOV  A,#6DH   ; "S"
   MOV  @R1,A    ; Save "S"
   DEC  R1
   MOV  A,#48H   ; "="
   MOV  @R1,A    ; Save "="

   MOV  R1,BUF   ; 0"E"543210<-
   MOV  R0,SCR   ; Score<-
   MOV  R2,#3
WI0:
   MOV  A,@R0    ; Get Score Low
   ANL  A,#0FH   ; Low Nibble
   CALL DIG      ; Make 7-Digit
   DIS  TCNTI
   MOV  @R1,A    ; Save it
   EN   TCNTI
   INC  R1
   MOV  A,@R0    ; Get Score Low
   ANL  A,#0F0H  ; Hi Nibble
   SWAP A        ; Hi<-> Low Nibble
   CALL DIG      ; Make 7-Digit
   DIS  TCNTI
   MOV  @R1,A    ; Save it
   EN   TCNTI
   INC  R1
   INC  R0
   DJNZ R2,WI0   ; 3 positions

   CALL DDS      ; R3,R4,R5,R6
   CALL ONESEC
   CALL ONESEC
   CALL ONESEC
   MOV  A,#00H   ; " "
   CALL FIL
   CALL DELAY100 ;
   JMP  WIN

;      8- ,
;       16   256 .
; movp a,@a      256 .    .